#ifndef _ttail_h__
#define _ttail_h__

#include <errno.h>
#include <stdio.h>

#include "options.h"
#include "dateformats.h"

struct _ttail_runtime_s
{
	///<! Date formats
	ttail_datefmt *fmt_l;

	///<! Formats count
	size_t fmt_sz;

	///<! Runtime options
	ttail_options *options;
};
typedef struct _ttail_runtime_s ttail_runtime_t;

/**@brief Init ttail lib
 *
 *Initialise the TTAIL_date_fmts and set the options
 */
ttail_runtime_t *ttail_init(int argc, char **argv);

#endif
